import { IPublicModelScrollable, ISensor, IPublicModelDropLocation, IPublicModelScrollTarget, IPublicModelPluginContext, IPublicModelLocateEvent } from '@alilc/lowcode-types';
import TreeNode from './tree-node';
import { ITreeBoard, TreeMaster } from './tree-master';
export declare class PaneController implements ISensor, ITreeBoard, IPublicModelScrollable {
    private pluginContext;
    private treeMaster?;
    readonly id: string;
    constructor(at: string | symbol, pluginContext: IPublicModelPluginContext, treeMaster: TreeMaster);
    /** -------------------- ISensor begin -------------------- */
    private indentTrack;
    /**
     * @see ISensor
     */
    fixEvent(e: IPublicModelLocateEvent): IPublicModelLocateEvent;
    /**
     * @see ISensor
     */
    locate(e: IPublicModelLocateEvent): IPublicModelDropLocation | undefined | null;
    /**
     * @see ISensor
     */
    isEnter(e: IPublicModelLocateEvent): boolean;
    /**
     * @see ISensor
     */
    deactiveSensor(): void;
    private _sensorAvailable;
    /**
     * @see ISensor
     */
    get sensorAvailable(): boolean;
    /** -------------------- ISensor end -------------------- */
    /** -------------------- ITreeBoard begin -------------------- */
    /**
     * @see ITreeBoard
     */
    readonly at: string | symbol;
    /**
     * @see ITreeBoard
     */
    scrollToNode(treeNode: TreeNode, detail?: any, tryTimes?: number): void;
    /** -------------------- ITreeBoard end -------------------- */
    private dwell;
    private getNear;
    private drillLocate;
    private tryScrollAgain;
    private sensing;
    /**
     * @see IScrollable
     */
    get bounds(): DOMRect | null;
    private _scrollTarget?;
    /**
     * @see IScrollable
     */
    get scrollTarget(): IPublicModelScrollTarget;
    private scroller?;
    purge(): void;
    private _shell;
    mount(shell: HTMLDivElement | null): void;
    private getInsertionRect;
    private getTreeNodeRect;
    private getTreeTitleRect;
    private getTreeSlotsRect;
}
