"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports["default"] = void 0;
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _lowcodeUtils = require("@alilc/lowcode-utils");
var TreeNode = /*#__PURE__*/function () {
  var _proto = TreeNode.prototype;
  /**
   * 触发 onExpandableChanged 回调
   */
  _proto.notifyExpandableChanged = function notifyExpandableChanged() {
    this.onExpandableChanged && this.onExpandableChanged(this.expandable);
  }

  /**
   * 插入"线"位置信息
   */;
  _proto.isRoot = function isRoot(includeOriginalRoot) {
    var _this$pluginContext$p;
    if (includeOriginalRoot === void 0) {
      includeOriginalRoot = false;
    }
    var rootNode = (_this$pluginContext$p = this.pluginContext.project.getCurrentDocument()) === null || _this$pluginContext$p === void 0 ? void 0 : _this$pluginContext$p.root;
    return this.tree.root === this || includeOriginalRoot && rootNode === this.node;
  }

  /**
   * 是否是响应投放区
   */;
  _proto.isResponseDropping = function isResponseDropping() {
    var _this$pluginContext$p2, _loc$target;
    var loc = (_this$pluginContext$p2 = this.pluginContext.project.getCurrentDocument()) === null || _this$pluginContext$p2 === void 0 ? void 0 : _this$pluginContext$p2.dropLocation;
    if (!loc) {
      return false;
    }
    return ((_loc$target = loc.target) === null || _loc$target === void 0 ? void 0 : _loc$target.id) === this.id;
  };
  _proto.isFocusingNode = function isFocusingNode() {
    var _this$pluginContext$p3, _loc$detail$focus, _loc$detail, _loc$detail$focus2;
    var loc = (_this$pluginContext$p3 = this.pluginContext.project.getCurrentDocument()) === null || _this$pluginContext$p3 === void 0 ? void 0 : _this$pluginContext$p3.dropLocation;
    if (!loc) {
      return false;
    }
    return (0, _lowcodeUtils.isLocationChildrenDetail)(loc.detail) && ((_loc$detail$focus = loc.detail.focus) === null || _loc$detail$focus === void 0 ? void 0 : _loc$detail$focus.type) === 'node' && ((_loc$detail = loc.detail) === null || _loc$detail === void 0 ? void 0 : (_loc$detail$focus2 = _loc$detail.focus) === null || _loc$detail$focus2 === void 0 ? void 0 : _loc$detail$focus2.node.id) === this.id;
  }

  /**
   * 默认为折叠状态
   * 在初始化根节点时，设置为展开状态
   */;
  _proto.setExpanded = function setExpanded(value) {
    this._expanded = value;
    this.onExpandedChanged && this.onExpandedChanged(value);
  };
  _proto.setHidden = function setHidden(flag) {
    if (this.node.conditionGroup) {
      return;
    }
    this.node.visible = !flag;
    this.onHiddenChanged && this.onHiddenChanged(flag);
  };
  _proto.setLocked = function setLocked(flag) {
    this.node.lock(flag);
    this.onLockedChanged && this.onLockedChanged(flag);
  };
  _proto.setTitleLabel = function setTitleLabel(label) {
    var origLabel = this.titleLabel;
    if (label === origLabel) {
      return;
    }
    if (label === '') {
      var _this$node$getExtraPr;
      (_this$node$getExtraPr = this.node.getExtraProp('title', false)) === null || _this$node$getExtraPr === void 0 ? void 0 : _this$node$getExtraPr.remove();
    } else {
      var _this$node$getExtraPr2;
      (_this$node$getExtraPr2 = this.node.getExtraProp('title', true)) === null || _this$node$getExtraPr2 === void 0 ? void 0 : _this$node$getExtraPr2.setValue(label);
    }
    this.onTitleLabelChanged && this.onTitleLabelChanged(this);
  };
  /**
   * 是否是容器，允许子节点拖入
   */
  _proto.isContainer = function isContainer() {
    return this.node.isContainerNode;
  }

  /**
   * 判断是否有"插槽"
   */;
  _proto.hasSlots = function hasSlots() {
    return this.node.hasSlots();
  };
  _proto.hasChildren = function hasChildren() {
    var _this$node$children;
    return !!(this.isContainer() && (_this$node$children = this.node.children) !== null && _this$node$children !== void 0 && _this$node$children.notEmptyNode);
  };
  _proto.select = function select(isMulti) {
    var _this$pluginContext$p4;
    var node = this.node;
    var selection = (_this$pluginContext$p4 = this.pluginContext.project.getCurrentDocument()) === null || _this$pluginContext$p4 === void 0 ? void 0 : _this$pluginContext$p4.selection;
    if (isMulti) {
      selection === null || selection === void 0 ? void 0 : selection.add(node.id);
    } else {
      selection === null || selection === void 0 ? void 0 : selection.select(node.id);
    }
  }

  /**
   * 展开节点，支持依次展开父节点
   */;
  _proto.expand = function expand(tryExpandParents) {
    if (tryExpandParents === void 0) {
      tryExpandParents = false;
    }
    // 这边不能直接使用 expanded，需要额外判断是否可以展开
    // 如果只使用 expanded，会漏掉不可以展开的情况，即在不可以展开的情况下，会触发展开
    if (this.expandable && !this._expanded) {
      this.setExpanded(true);
    }
    if (tryExpandParents) {
      this.expandParents();
    }
  };
  _proto.expandParents = function expandParents() {
    var p = this.node.parent;
    while (p) {
      this.tree.getTreeNode(p).setExpanded(true);
      p = p.parent;
    }
  };
  function TreeNode(tree, node, pluginContext) {
    this.pluginContext = void 0;
    this.onFilterResultChanged = void 0;
    this.onExpandedChanged = void 0;
    this.onHiddenChanged = void 0;
    this.onLockedChanged = void 0;
    this.onTitleLabelChanged = void 0;
    this.onExpandableChanged = void 0;
    this._expanded = false;
    this._node = void 0;
    this.tree = void 0;
    this._filterResult = {
      filterWorking: false,
      matchChild: false,
      matchSelf: false,
      keywords: ''
    };
    this.tree = tree;
    this.pluginContext = pluginContext;
    this._node = node;
  }
  _proto.setNode = function setNode(node) {
    if (this._node !== node) {
      this._node = node;
    }
  };
  _proto.setFilterReult = function setFilterReult(val) {
    this._filterResult = val;
    if (this.onFilterResultChanged) {
      this.onFilterResultChanged();
    }
  };
  (0, _createClass2["default"])(TreeNode, [{
    key: "id",
    get: function get() {
      return this.node.id;
    }

    /**
     * 是否可以展开
     */
  }, {
    key: "expandable",
    get: function get() {
      var _this$dropDetail;
      if (this.locked) return false;
      return this.hasChildren() || this.hasSlots() || ((_this$dropDetail = this.dropDetail) === null || _this$dropDetail === void 0 ? void 0 : _this$dropDetail.index) != null;
    }
  }, {
    key: "dropDetail",
    get: function get() {
      var _this$pluginContext$p5;
      var loc = (_this$pluginContext$p5 = this.pluginContext.project.getCurrentDocument()) === null || _this$pluginContext$p5 === void 0 ? void 0 : _this$pluginContext$p5.dropLocation;
      return loc && this.isResponseDropping() && (0, _lowcodeUtils.isLocationChildrenDetail)(loc.detail) ? loc.detail : null;
    }
  }, {
    key: "depth",
    get: function get() {
      return this.node.zLevel;
    }
  }, {
    key: "expanded",
    get: function get() {
      return this.isRoot(true) || this.expandable && this._expanded;
    }
  }, {
    key: "detecting",
    get: function get() {
      var doc = this.pluginContext.project.currentDocument;
      return !!(doc !== null && doc !== void 0 && doc.isDetectingNode(this.node));
    }
  }, {
    key: "hidden",
    get: function get() {
      var cv = this.node.isConditionalVisible();
      if (cv == null) {
        return !this.node.visible;
      }
      return !cv;
    }
  }, {
    key: "locked",
    get: function get() {
      return this.node.isLocked;
    }
  }, {
    key: "selected",
    get: function get() {
      var _this$pluginContext$p6;
      // TODO: check is dragging
      var selection = (_this$pluginContext$p6 = this.pluginContext.project.getCurrentDocument()) === null || _this$pluginContext$p6 === void 0 ? void 0 : _this$pluginContext$p6.selection;
      if (!selection) {
        return false;
      }
      return selection === null || selection === void 0 ? void 0 : selection.has(this.node.id);
    }
  }, {
    key: "title",
    get: function get() {
      return this.node.title;
    }
  }, {
    key: "titleLabel",
    get: function get() {
      var title = this.title;
      if (!title) {
        return '';
      }
      if (title.label) {
        title = title.label;
      }
      if (typeof title === 'string') {
        return title;
      }
      if ((0, _lowcodeUtils.isI18nData)(title)) {
        var currentLocale = this.pluginContext.getLocale();
        var currentTitle = title[currentLocale];
        return currentTitle;
      }
      return this.node.componentName;
    }
  }, {
    key: "icon",
    get: function get() {
      return this.node.componentMeta.icon;
    }
  }, {
    key: "parent",
    get: function get() {
      var parent = this.node.parent;
      if (parent) {
        return this.tree.getTreeNode(parent);
      }
      return null;
    }
  }, {
    key: "slots",
    get: function get() {
      var _this = this;
      // todo: shallowEqual
      return this.node.slots.map(function (node) {
        return _this.tree.getTreeNode(node);
      });
    }
  }, {
    key: "children",
    get: function get() {
      var _this$node$children2,
        _this2 = this;
      return ((_this$node$children2 = this.node.children) === null || _this$node$children2 === void 0 ? void 0 : _this$node$children2.map(function (node) {
        return _this2.tree.getTreeNode(node);
      })) || null;
    }
  }, {
    key: "node",
    get: function get() {
      return this._node;
    }
  }, {
    key: "filterReult",
    get: function get() {
      return this._filterResult;
    }
  }]);
  return TreeNode;
}();
exports["default"] = TreeNode;